property mraBaseName, mraNrOfFrames, mraStartFrame, mraRollType, mraNrOfLoops, mraEnabled, mraVisible, mraCurrentFrame, mraCurrentLoop, mraMouseDownmember, mraMouseDown, mraActive, mraDeactivemember, mraDelay, mraLastTime, mraLoopback, mraBackEnabled

on GetMembernum me
  name = mraBaseName & string(mraCurrentFrame)
  number = member(member(name).memberNum)
  return number
end

on MasterRollShow me
  mraVisible = 1
  sprite(the currentSpriteNum).visible = mraVisible
  MasterRollDisable(me)
end

on MasterRollHide me
  mraVisible = 0
  sprite(the currentSpriteNum).visible = mraVisible
end

on MasterRollActivate me
  mraActive = 1
end

on MasterRollDeActivate me
  mraActive = 0
  if mraDeactivemember <> EMPTY then
    set the member of sprite the currentSpriteNum to mraDeactivemember
  end if
end

on MasterRollEnable me
  if mraVisible then
    if mraActive then
      mraEnabled = 1
      mraCurrentFrame = mraStartFrame
      set the member of sprite the currentSpriteNum to GetMembernum(me)
    end if
  end if
end

on MasterRollDisable me
  if mraVisible then
    if mraActive then
      mraEnabled = 0
      mraCurrentFrame = mraStartFrame
      set the member of sprite the currentSpriteNum to GetMembernum(me)
    end if
  end if
end

on beginSprite me
  mraLastTime = the milliSeconds
  mraCurrentLoop = 1
  sprite(the currentSpriteNum).visible = mraVisible
end

on mouseEnter me
  if mraVisible then
    if mraActive then
      if not mraMouseDown then
        MasterRollEnable(me)
      else
        set the member of sprite the currentSpriteNum to mraMouseDownmember
      end if
    end if
  end if
end

on mouseWithin me
  if mraVisible then
    if mraActive then
      if not mraEnabled and not mraMouseDown then
        MasterRollEnable(me)
      end if
    end if
  end if
end

on mouseLeave me
  if mraVisible then
    if mraActive then
      if (mraLoopback = #Yes) and mraEnabled and (mraRollType = #Highlight) and not mraMouseDown then
        mraBackEnabled = 1
      else
        MasterRollDisable(me)
        mraCurrentLoop = 1
      end if
    end if
  end if
end

on mouseDown me
  if mraVisible then
    if mraActive then
      mraMouseDown = 1
      MasterRollDisable(me)
      set the member of sprite the currentSpriteNum to mraMouseDownmember
      pass()
    end if
  end if
end

on mouseUp me
  if mraMouseDown = 1 then
    if mraVisible then
      if mraActive then
        mraMouseDown = 0
        MasterRollEnable(me)
      end if
    end if
  else
    stopEvent()
  end if
end

on mouseUpOutSide me
  if mraVisible then
    if mraActive then
      mraMouseDown = 0
      MasterRollEnable(me)
      mouseLeave(me)
    end if
  end if
end

on prepareFrame me
  if the milliSeconds > (mraLastTime + mraDelay) then
    mraLastTime = the milliSeconds
    if mraVisible then
      if mraActive then
        if mraEnabled then
          if (mraCurrentLoop <= mraNrOfLoops) or (mraNrOfLoops = 0) then
            if mraBackEnabled = 1 then
              if mraRollType = #Highlight then
                mraCurrentFrame = mraCurrentFrame - 1
                if mraCurrentFrame = (mraStartFrame - 1) then
                  MasterRollDisable(me)
                  mraCurrentLoop = 1
                  mraBackEnabled = 0
                else
                  set the member of sprite the currentSpriteNum to GetMembernum(me)
                end if
              end if
            else
              mraCurrentFrame = mraCurrentFrame + 1
              if mraCurrentFrame > mraNrOfFrames then
                if mraRollType = #Animation then
                  mraCurrentFrame = 1
                  mraCurrentLoop = mraCurrentLoop + 1
                else
                  mraCurrentFrame = mraCurrentFrame - 1
                end if
              end if
              set the member of sprite the currentSpriteNum to GetMembernum(me)
            end if
          else
            MasterRollDisable(me)
          end if
        end if
      end if
    end if
  end if
end

on getPropertyDescriptionList
  p_list = [#mraBaseName: [#comment: "Basename of the memberpics:", #format: #string, #default: "Anim"], #mraNrOfFrames: [#comment: "Number of pics in the animation:", #format: #integer, #default: 2], #mraStartFrame: [#comment: "Startingframe of the animation:", #format: #integer, #default: 1], #mraDelay: [#comment: "Delay for animation in sec/1000", #format: #integer, #default: 0], #mraRollType: [#comment: "Type of the animation:", #format: #symbol, #range: [#Animation, #Highlight], #default: #Animation], #mraLoopback: [#comment: "Animate on MouseLeave", #format: #symbol, #range: [#Yes, #No], #default: #No], #mraNrOfLoops: [#comment: "Times the animation is played:", #format: #integer, #default: 1], #mraEnabled: [#comment: "Initial playing:", #format: #boolean, #default: 0], #mraVisible: [#comment: "Initial visible:", #format: #boolean, #default: 1], #mraActive: [#comment: "Initial active:", #format: #boolean, #default: 1], #mraMouseDownmember: [#comment: "Mousedown picture:", #format: #string, #default: "AnimDown"], #mraDeactivemember: [#comment: "Inactive picture:", #format: #string, #default: "AnimInactive"]]
  return p_list
end
